#include	<stdio.h>
#include	"a.out.h"

/* Fix to work when running on big-endian systems - */
/* jim.hague@acm.org, 1998-02-06. */

/* These will be a complete waste of time on a lo-endian */
/* system, but it only gets done once so WTF. */
static long i86l_to_host(long l)
{
    long res = 0;
    int i;
    union
    {
    	unsigned char c[4];
	long l;
    } u;

    u.l = l;
    for (i = 3; i >= 0; i--)
    	res = (res << 8) + u.c[i];
    return res;
}

void objdump(filename)
	char	*filename;
{
	FILE	*f;
	struct exec	ex;
	long	i;
	long textsize, datasize;

	if ((f = fopen(filename, "r")) == NULL)
	{
		perror(filename);
		return;
	}
	if (fread(&ex, sizeof(ex), 1, f) != 1)
	{
		fprintf(stderr, "%s: Cannot read header\n", filename);
		fclose(f);
		return;
	}
	if (BADMAG(ex))
	{
		fprintf(stderr, "%s: Not an a.out file\n", filename);
		fclose(f);
		return;
	}
	if (fseek(f, (long)A_HEADERSIZ, SEEK_SET) < 0)
	{
		fprintf(stderr, "Fseek failed on %s\n", filename);
		fclose(f);
		exit(1);
	}
	textsize = i86l_to_host(ex.a_text);
	datasize = i86l_to_host(ex.a_data);
	for (i =  textsize + datasize; i > 0; --i)
		putchar(fgetc(f));
	fclose(f);
}

int main(argc, argv)
	int	argc;
	char	**argv;
{
	if (argc < 2)
	{
		fprintf(stderr, "Usage: %s file\n", argv[0]);
		exit(1);
	}
	objdump(argv[1]);
	exit(0);
}
/*
 * Local variables:
 *  c-basic-offset: 8
 * End:
 */

