#include	<fcntl.h>
#include	<a.out.h>

/* Fix to work when running on big-endian systems - */
/* jim.hague@acm.org, 1998-02-06. */

/* These will be a complete waste of time on a lo-endian */
/* system, but it only gets done once so WTF. */
static long i86l_to_host(long l)
{
    long res = 0;
    int i;
    union
    {
    	unsigned char c[4];
	long l;
    } u;

    u.l = l;
    for (i = 3; i >= 0; i--)
    	res = (res << 8) + u.c[i];
    return res;
}

void size(filename)
	char	*filename;
{
	int	f;
	struct exec	ex;
	long	total;
	int	cc;

	if ((f = open(filename, O_RDONLY)) < 0 )
	{
		perror(filename);
		return;
	}
	cc = read(f, &ex, sizeof(ex));

	if (cc == sizeof(ex) && !BADMAG(ex))
	{
		ex.a_text = i86l_to_host(ex.a_text);
		ex.a_data = i86l_to_host(ex.a_data);
		ex.a_bss = i86l_to_host(ex.a_bss);
		total = ex.a_text + ex.a_data + ex.a_bss;
		printf("%-ld\t%-ld\t%-ld\t%-ld\t%-lx\t%s\n",
			ex.a_text, ex.a_data, ex.a_bss, total, total,	
			filename);
	}
	else if( cc > 16 && memcmp(&ex, "\243\206\001\000*", 5) == 0 )
	{	/* *.o file */
		total = ((unsigned char*)&ex)[9] +
		        ((unsigned char*)&ex)[10] * 256;
		printf("\t\t\t%-ld\t%-lx\t%s\n",
			total, total, filename);
	}
	else
		printf("%s: Not an a.out file\n", filename);
	close(f);
}

int main(argc, argv)
	int	argc;
	char	**argv;
{
	if (argc < 2)
	{
		printf("Usage: %s file\n", argv[0]);
		exit(1);
	}
	printf("text\tdata\tbss\tdec\thex\tfilename\n");
	for (--argc, ++argv; argc > 0; --argc, ++argv)
		size(*argv);
	exit(0);
}
/*
 * Local variables:
 *  c-basic-offset: 8
 * End:
 */

